/*
  Virtual pixel
 
 An example of using the Arduino board to send data to the computer.  
 In this case, the Arduino performs an infinite loop where it sends 
 values 0 to 100 intermitted with delays
 
 Created March 2013
 by Peter Peters
 */

void setup() {
  // initialize serial communication:
  Serial.begin(38400);
}

void loop() {
  // send data to processing
  for (int i=0; i < 100; i++) {
    Serial.println(i);
    delay(50);  
  }
}

/* Processing code for this example

// Demonstrates how to receive data from the Arduino board, in order to 
// turn on and off a virtual pixel
// 
// Created March 2013
// by Peter Peters

import processing.serial.*; 

int boxSize = 20;
Serial port; 

void setup() {
  size(200, 200);

  // List all the available serial ports in the output pane. 
  // Choose the port that the Arduino board is connected to from this list.
  // The first port in the list is port #0 

    println(Serial.list()); 

  // Open the port that the Arduino board is connected to (in this case #0) 
  // Make sure to open the port at the same speed Arduino is using (9600bps)

  port = new Serial(this, Serial.list()[1], 9600);
}

void draw() 
{ 
  if (port.available() > 0) {
    background(0);
    int ch = port.read();
    // print(ch); print(' ');
    if (ch > 50) drawCenteredBox(color(255, 0, 0));
    else drawCenteredBox(color(255, 255, 255));
  }
}

void drawCenteredBox(color col) {
  fill(col);
  rect((width/2)-(boxSize/2), (height/2)-(boxSize/2), 
  (boxSize), boxSize);
}

 */
