#include <SoftwareSerial.h>
#include <Streaming.h>

//#define DEBUG
#define rxPin 2
#define txPin 3
#define ledPin 13

SoftwareSerial sSerial = SoftwareSerial(rxPin, txPin);

void setup() {
  pinMode(rxPin,INPUT);
  pinMode(txPin,OUTPUT);
  sSerial.begin(115200);
#ifdef DEBUG
  Serial.begin(56700);
#endif
  // define led pin as output
  pinMode(ledPin,OUTPUT);
  // define analog sensor pins as input
  pinMode(A0,INPUT); 
  pinMode(A1,INPUT);
  pinMode(A2,INPUT);
  pinMode(A3,INPUT);
  rebootWiFly();
}

long now = millis();
boolean repeat = false;

String cmd = "";
void loop() { 
  if (repeat) { 
    if ((millis() - now) > 100) {   
      now = millis(); 
      sensorData();   
    }
  }
  //
  // Read command from WiFly
  //
  while (sSerial.available() > 0) {
    char ch = sSerial.read();
      processCommand(ch);
  }
}

void processCommand(char ch) {
  switch(ch) {
  case '1': 
    digitalWrite(ledPin,HIGH);
    break;
  case '0': 
    digitalWrite(ledPin,LOW);
    break;
  case 'r':
    repeat = ! repeat;
    digitalWrite(ledPin,! digitalRead(ledPin));
    break;
  case '?':
    if (! repeat) sensorData();
    break;
  case '!':
    rebootWiFly();
    break; 
  }
}

void sensorData() {
  sSerial << analogRead(A0) << F(",") 
    << analogRead(A1) << F(",") 
      << analogRead(A2) << F(",") 
        << analogRead(A3) << endl; 
#ifdef DEBUG
  Serial << analogRead(A0) << F(",") 
    << analogRead(A1) << F(",") 
      << analogRead(A2) << F(",") 
        << analogRead(A3) << endl;               
#endif
}

void rebootWiFly() {
  // write 3 $ characters with pause of 250 ms
  sSerial << F("$$$");
  delay(250);
  // send reboot command
  sSerial << F("reboot") << endl;
}














