// read sensor values from Pachube feed

import eeml.*;

// program constants

// The key is needed for identification purposes
// If the feed you read is public, any key will do
// if the feed is private, you'll need the specific key of the feed owner
String apiKey   = "IbMuMnl9sEhB62GlKNqzT88z8smSAKxwRXVPdk1oQ2o2az0g";

// The url to use to read the feed, usually something like 
// http://www.pachube.com/api/xxxxx.xml
// where the xxxxx is the feed ID that was generated when creating the feed
// (also visible when selecting the feed on the Pachube website
String feedURL  = "http://www.pachube.com/api/91613.xml";

// font used to write ldr value
PFont myFont;
// Pachube input stream
DataIn dIn;
// light sensor value received via Pachube stream
float ldrval = 0;

void setup() {
  // set up DataIn object; indicate the URL you want, your Pachube API key,
  // and how often you want it to update e.g. every 2 seconds
  dIn = new DataIn(this, feedURL, apiKey, 2000);
  // set window width and height
  size (200, 200);
  //and font to use
  myFont = createFont("ArialMT", 48);
  textFont(myFont);
  textAlign(CENTER);
}

void draw()
{
  // color background dependent on input value
  background(255-map(ldrval, 600, 1024, 0, 255));
  // and display the value in text
  text(int(ldrval), width/2, height/2);
}

// onReceiveEEML is run every time your app receives back EEML 
// that it has requested from a Pachube feed.
void onReceiveEEML(DataIn d)
{
  ldrval = d.getValue(0);
  // Here you make sure the data received is between defined boundaries
  // check the language reference on what constrain does!
  // The range chosen depends on the values the data is expected
  // to deliver. You should adapt the 600, 1023 values to your sensor range
  ldrval = constrain(ldrval, 600, 1023);
}


